# Blitter_Null Class Reference

Inheritance diagram for Blitter_Null:

## Public Member Functions
uint8 | GetScreenDepth ()
| Get the screen depth this blitter works for.
void | Draw (Blitter::BlitterParams *bp, BlitterMode mode, ZoomLevel zoom)
| Draw an image to the screen, given an amount of params defined above.
void | DrawColourMappingRect (void *dst, int width, int height, PaletteID pal)
| Draw a colourtable to the screen.
Sprite * | Encode (SpriteLoader::Sprite *sprite, Blitter::AllocatorProc *allocator)
| Convert a sprite from the loader to our own format.
void * | MoveTo (const void *video, int x, int y)
| Move the destination pointer the requested amount x and y, keeping in mind any pitch and bpp of the renderer.
void | SetPixel (void *video, int x, int y, uint8 colour)
| Draw a pixel with a given colour on the video-buffer.
void | DrawRect (void *video, int width, int height, uint8 colour)
| Make a single horizontal line in a single colour on the video-buffer.
void | DrawLine (void *video, int x, int y, int x2, int y2, int screen_width, int screen_height, uint8 colour)
| Draw a line with a given colour.
void | CopyFromBuffer (void *video, const void *src, int width, int height)
| Copy from a buffer to the screen.
void | CopyToBuffer (const void *video, void *dst, int width, int height)
| Copy from the screen to a buffer.
void | CopyImageToBuffer (const void *video, void *dst, int width, int height, int dst_pitch)
| Copy from the screen to a buffer in a palette format for 8bpp and RGBA format for 32bpp.
void | ScrollBuffer (void *video, int &left, int &top, int &width, int &height, int scroll_x, int scroll_y)
| Scroll the videobuffer some 'x' and 'y' value.
int | BufferSize (int width, int height)
| Calculate how much memory there is needed for an image of this size in the video-buffer.
void | PaletteAnimate (uint start, uint count)
| Called when the 8bpp palette is changed; you should redraw all pixels on the screen that are equal to the 8bpp palette indexes 'start' to 'start + count'.
Blitter::PaletteAnimation | UsePaletteAnimation ()
| Check if the blitter uses palette animation at all.
const char * | GetName ()
| Get the name of the blitter, the same as the Factory-instance returns.
int | GetBytesPerPixel ()
| Get how many bytes are needed to store a pixel.

## Detailed Description

Definition at line 18 of file null.hpp.

## Member Function Documentation

int Blitter_Null::BufferSize | ( | int | width,
|  | int | height |
| ) |  |  | `[inline, virtual]`

Calculate how much memory there is needed for an image of this size in the video-buffer.

Parameters:

  | width | The width of the buffer-to-be.
  | height | The height of the buffer-to-be.

Returns:
  The size needed for the buffer.

Implements Blitter.

Definition at line 32 of file null.hpp.

void Blitter_Null::CopyFromBuffer | ( | void * | video,
|  | const void * | src,
|  | int | width,
|  | int | height |
| ) |  |  | `[inline, virtual]`

Copy from a buffer to the screen.

Parameters:

  | video | The destionation pointer (video-buffer).
  | src | The buffer from which the data will be read.
  | width | The width of the buffer.
  | height | The height of the buffer.

Note:
  You can not do anything with the content of the buffer, as the blitter can store non-pixel data in it too!

Implements Blitter.

Definition at line 28 of file null.hpp.

void Blitter_Null::CopyImageToBuffer | ( | const void * | video,
|  | void * | dst,
|  | int | width,
|  | int | height,
|  | int | dst_pitch |
| ) |  |  | `[inline, virtual]`

Copy from the screen to a buffer in a palette format for 8bpp and RGBA format for 32bpp.

Parameters:

  | video | The destination pointer (video-buffer).
  | dst | The buffer in which the data will be stored.
  | width | The width of the buffer.
  | height | The height of the buffer.
  | dst_pitch | The pitch (byte per line) of the destination buffer.

Implements Blitter.

Definition at line 30 of file null.hpp.

void Blitter_Null::CopyToBuffer | ( | const void * | video,
|  | void * | dst,
|  | int | width,
|  | int | height |
| ) |  |  | `[inline, virtual]`

Copy from the screen to a buffer.

Parameters:

  | video | The destination pointer (video-buffer).
  | dst | The buffer in which the data will be stored.
  | width | The width of the buffer.
  | height | The height of the buffer.

Note:
  You can not do anything with the content of the buffer, as the blitter can store non-pixel data in it too!

Implements Blitter.

Definition at line 29 of file null.hpp.

void Blitter_Null::DrawColourMappingRect | ( | void * | dst,
|  | int | width,
|  | int | height,
|  | PaletteID | pal |
| ) |  |  | `[inline, virtual]`

Draw a colourtable to the screen.

This is: the colour of the screen is read and is looked-up in the palette to match a new colour, which then is put on the screen again.

Parameters:

  | dst | the destination pointer (video-buffer).
  | width | the width of the buffer.
  | height | the height of the buffer.
  | pal | the palette to use.

Implements Blitter.

Definition at line 22 of file null.hpp.

void Blitter_Null::DrawLine | ( | void * | video,
|  | int | x,
|  | int | y,
|  | int | x2,
|  | int | y2,
|  | int | screen_width,
|  | int | screen_height,
|  | uint8 | colour |
| ) |  |  | `[inline, virtual]`

Draw a line with a given colour.

Parameters:

  | video | The destination pointer (video-buffer).
  | x | The x coordinate from where the line starts.
  | y | The y coordinate from where the line starts.
  | x2 | The x coordinate to where the line goes.
  | y2 | The y coordinate to where the lines goes.
  | screen_width | The width of the screen you are drawing in (to avoid buffer-overflows).
  | screen_height | The height of the screen you are drawing in (to avoid buffer-overflows).
  | colour | A 8bpp mapping colour.

Implements Blitter.

Definition at line 27 of file null.hpp.

void Blitter_Null::DrawRect | ( | void * | video,
|  | int | width,
|  | int | height,
|  | uint8 | colour |
| ) |  |  | `[inline, virtual]`

Make a single horizontal line in a single colour on the video-buffer.

Parameters:

  | video | The destination pointer (video-buffer).
  | width | The length of the line.
  | height | The height of the line.
  | colour | A 8bpp mapping colour.

Implements Blitter.

Definition at line 26 of file null.hpp.

uint8 Blitter_Null::GetScreenDepth | ( |  | ) | `[inline, virtual]`

Get the screen depth this blitter works for.

This is either: 8, 16, 24 or 32.

Implements Blitter.

Definition at line 20 of file null.hpp.

void* Blitter_Null::MoveTo | ( | const void * | video,
|  | int | x,
|  | int | y |
| ) |  |  | `[inline, virtual]`

Move the destination pointer the requested amount x and y, keeping in mind any pitch and bpp of the renderer.

Parameters:

  | video | The destination pointer (video-buffer) to scroll.
  | x | How much you want to scroll to the right.
  | y | How much you want to scroll to the bottom.

Returns:
  A new destination pointer moved the the requested place.

Implements Blitter.

Definition at line 24 of file null.hpp.

void Blitter_Null::PaletteAnimate | ( | uint | start,
|  | uint | count |
| ) |  |  | `[inline, virtual]`

Called when the 8bpp palette is changed; you should redraw all pixels on the screen that are equal to the 8bpp palette indexes 'start' to 'start + count'.

Parameters:

  | start | The start index in the 8bpp palette.
  | count | The amount of indexes that are (possible) changed.

Implements Blitter.

Definition at line 33 of file null.hpp.

void Blitter_Null::ScrollBuffer | ( | void * | video,
|  | int & | left,
|  | int & | top,
|  | int & | width,
|  | int & | height,
|  | int | scroll_x,
|  | int | scroll_y |
| ) |  |  | `[inline, virtual]`

Scroll the videobuffer some 'x' and 'y' value.

Parameters:

  | video | The buffer to scroll into.
  | left | The left value of the screen to scroll.
  | top | The top value of the screen to scroll.
  | width | The width of the screen to scroll.
  | height | The height of the screen to scroll.
  | scroll_x | How much to scroll in X.
  | scroll_y | How much to scroll in Y.

Implements Blitter.

Definition at line 31 of file null.hpp.

void Blitter_Null::SetPixel | ( | void * | video,
|  | int | x,
|  | int | y,
|  | uint8 | colour |
| ) |  |  | `[inline, virtual]`

Draw a pixel with a given colour on the video-buffer.

Parameters:

  | video | The destination pointer (video-buffer).
  | x | The x position within video-buffer.
  | y | The y position within video-buffer.
  | colour | A 8bpp mapping colour.

Implements Blitter.

Definition at line 25 of file null.hpp.

Blitter::PaletteAnimation Blitter_Null::UsePaletteAnimation | ( |  | ) | `[inline, virtual]`

Check if the blitter uses palette animation at all.

Returns:
  True if it uses palette animation.

Implements Blitter.

Definition at line 34 of file null.hpp.

References Blitter::PALETTE_ANIMATION_NONE.

The documentation for this class was generated from the following files:

- src/blitter/null.hpp
- src/blitter/null.cpp